static char rcs_id[] =
  "$Id: main.c,v 1.59 2002/07/31 14:35:14 blues Exp $";

/* Intro {{{
 * ---------------------------------------------------------------- 
 *  DirectConnect HUB for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dc.ds.pg.gda.pl/
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- 
 * }}} */

/* include for PCH file	*/
#include "pch.h"

/* ChangeLog  {{{
 * $Log: main.c,v $
 * Revision 1.59  2002/07/31 14:35:14  blues
 * - one TODO is out - it's possible now to turn off chats
 *
 * Revision 1.58  2002/07/31 12:56:11  blues
 * - basic frame for $UniSearch
 *
 * Revision 1.57  2002/07/30 16:15:10  blues
 * - all files have now vim helpers - in *.h files only Intro and ChangeLog
 *   are hidden. In *.c files all functions are hidden.
 * - added "/" at the end of address, fixed missing.
 *
 * Revision 1.56  2002/07/30 15:42:27  blues
 * - one more helper for vim
 *
 * Revision 1.55  2002/07/20 19:13:02  blues
 * - more helper signs for vim
 *
 * Revision 1.54  2002/06/30 11:46:39  blues
 * - fixed privmessage handling
 *
 * Revision 1.53  2002/06/30 11:01:00  blues
 * - nice comments on not supported options
 *
 * Revision 1.52  2002/06/30 08:37:45  blues
 * - well... all HUPing is back... to many hours I'm sitting here - I've got
 *   brain-damage....
 *
 * Revision 1.51  2002/06/30 08:20:52  blues
 * - temporary removed reopening log file on SIGHUP
 *
 * Revision 1.50  2002/06/30 08:10:38  blues
 * - user nobody is back - daemon does not have to own anything
 *
 * Revision 1.49  2002/06/30 06:44:10  blues
 * - more logging
 *
 * Revision 1.48  2002/06/30 04:04:08  blues
 * - added MOTD utility
 *
 * Revision 1.47  2002/06/30 03:05:09  blues
 * - more cleanups
 * - one lost setuid/setgid corrected
 *
 * Revision 1.46  2002/06/30 02:58:28  blues
 * - cleanups
 *
 * Revision 1.45  2002/06/30 02:03:10  blues
 * - even more cleanups
 * - UID and GID are now config options
 * - status expanded
 *
 * Revision 1.44  2002/06/29 23:50:59  blues
 * - massive attack:
 * - new logging scheme - used Log Writer Library
 * - autoconf stuff adapted partially
 *
 * Revision 1.43  2002/06/15 13:04:21  blues
 * - Done things added to NEWS
 * - fixed handling config-file, killed some sig11 - functional now (0.0.5
 *   ready, I think...)
 *
 * Revision 1.42  2002/05/31 15:17:31  blues
 * - few words in README and added web site address in welcome message.
 *
 * Revision 1.41  2002/05/30 15:30:04  blues
 * - some things should be send to syslog
 *
 * Revision 1.40  2002/05/28 18:40:19  sebo
 * Simple config file parser and minimum share requirements.
 * Please view the changes and test it.
 *
 * Revision 1.39  2002/05/28 10:34:59  blues
 * - nicer comments
 *
 * Revision 1.38  2002/05/18 12:54:09  blues
 * - some cosmetics in comments
 *
 * Revision 1.37  2002/05/14 09:59:51  sebo
 * - empty users bugfix
 * - registration timeout introduced (default = 30sec.)
 * - a listen() backlog issue corrected
 *
 * Revision 1.36  2002/05/08 11:00:42  sebo
 * Some update
 *
 * Revision 1.35  2002/05/07 08:42:27  sebo
 * Problem with libwrap hopfuly solved.
 *
 * Revision 1.34  2002/05/07 08:24:20  sebo
 * Small fix.
 *
 * Revision 1.33  2002/05/06 22:03:56  sebo
 * Ignoring too long lines instead of shutting down hub. Not tested 'cause I'm going to bed ;-)
 *
 * Revision 1.32  2002/05/06 18:54:31  sebo
 * $MultiConnectToMe "support"
 *
 * Revision 1.31  2002/04/28 12:36:19  sebo
 * Daemon mode now works (I hope) and is the default. `-d' debug mode introduced.
 *
 * Revision 1.30  2002/04/28 12:27:26  blues
 * - move this logging to main function (do not show on every thread create)
 *
 * Revision 1.29  2002/04/28 12:21:51  blues
 * - Started logging to syslog
 *
 * Revision 1.28  2002/04/27 18:21:10  ventox
 * Initial revision
 *
 * }}} */

/* include local header files {{{ */
#include "main.h"

#include "conf.h"
#include "misc.h"
#include "net.h"
 /* }}} */

/* users table	*/
struct userrec *user[MAXUSERS];

/* configuration data	*/
struct config conf;
int NUSERS;
int linerd=1;			// line-read-and-ready flag
/* assume command length (from '$' to '|') doesn't exceed BUF_SIZE	*/
char line[BUF_SIZE];
pthread_t listen_th;
fd_set sockfdset;
struct sockaddr_in local;
int listen_sock;

int allow_severity=LOG_INFO;
int deny_severity=LOG_WARNING;
#ifdef HAVE___PROGNAME
extern char *__progname;
#else
char *__progname;
#endif

struct request_info req;

/* log file handler	*/
lwlh_t h;


/* adduser() - allocate and init new user {{{ */
void adduser( int * sock, char * remote ) 
{
	char lock[128];
	struct userrec *tmp;
	struct timeval tv;
	
	tmp=(struct userrec *)malloc(sizeof(struct userrec));
	bzero(tmp,sizeof(struct userrec));
	tmp->sock=dup(*sock);
	if (setsockopts(&(tmp->sock))<0)
		lwl_write_log (h, LWL_PRI_ERR, "Error setsockopt: %s", strerror(errno));
	/* 
	 * we use select() anyway, but let's care for blocking send()
	 */
	if (fcntl(tmp->sock,F_SETFL,O_NONBLOCK)<0)
		lwl_write_log (h, LWL_PRI_ERR, "Error fcntl: %s", strerror(errno));
	lockgen(lock);
	sendf_to(tmp,"$Lock %s",lock);
	sendf_to(tmp,"$HubName %s",conf.hubname);
	/* 
	 * client complains that it couldn't find $Lock when msgs are sent before it
	 */
	publicmsg(NULL,tmp,"This Hub is running DConnect Daemon for Linux. http://www.dc.ds.pg.gda.pl");
	
	if (denied(&(tmp->sock))) {
		disconnect(tmp,"You're not allowed to connect. Good bye."); return; }
	if (banned(remote)) {
		disconnect(tmp,"Your IP is banned!"); return; }
	if (NUSERS>=conf.userlimit) {
		disconnect(tmp,"Sorry, this Hub is currently Full!"); return; }
	
	strcpy(tmp->ip,remote);
	gettimeofday(&tv,NULL);
	tmp->ping=tv.tv_sec;
	tmp->flag=1;
	user[NUSERS++]=tmp;
	FD_SET(tmp->sock,&sockfdset);
} /* }}} */

/* deluser() - flush user's data {{{ */
void deluser(int id,char *reason) {
	struct userrec *tmp;
	
	if ((id<0)||(id>=MAXUSERS)||(!user[id])) return;
	tmp=user[id];
	user[id]=user[--NUSERS];
	user[NUSERS]=NULL;
	FD_CLR(tmp->sock,&sockfdset);
	if (tmp->state>=2) sendf_mcast("$Quit %s",tmp->nick);
	disconnect(tmp,reason);
} /* }}} */

/* finish() - signal handler and program termination {{{ */
void finish(int sig)
{
	int n;
	switch(sig)
	{
		/* What for is that signal? - blues */
		case SIGPIPE: return;
                /* Reload config file when you get SIGHUP */
		case SIGHUP: lwl_write_log (h, LWL_PRI_INFO, "SIGHUP received. Reloading configuration.");
			     read_config(&conf);
			     /* temporary removed - doesn't work good... - blues */
			     lwl_write_log (h, LWL_PRI_DEBUG, "Clossing logfile.");
			     lwl_free (h);
			     h = lwl_alloc ();
			     init_log(&conf,h);
			     return;
		default: pthread_cancel(listen_th);
			 pthread_join(listen_th,NULL);
			 for (n=0;n<NUSERS;n++) disconnect(user[n],"Hub shutdown!");
			 /* logging via syslog */
			 openlog ("dcd", LOG_PID | LOG_CONS, LOG_DAEMON);
			 syslog(LOG_NOTICE, "Shutting down, DConnect Daemon");
			 lwl_write_log (h, LWL_PRI_INFO, "Shutting down, DConnect Daemon");
			 lwl_free (h);
			 exit(sig);
	}
} /* }}} */

/* buf2line() - point 'pos' to the beginning of a new line in 'buf' {{{ */
static int buf2line(int *pos,char *buf) {
	int x=0;
	char tmp[BUF_SIZE];
	if (!buf[*pos]) return 0;
	if (linerd) *line=0;
	while((buf[*pos]!='|')&&buf[*pos]&&(x<BUF_SIZE-1)) tmp[x++]=buf[(*pos)++];
	tmp[x]=0;
	if (strlen(line)+x>BUF_SIZE-1) { 
		puts("Line too long - ignored."); *line=0; return linerd=0; }
	strcat(line,tmp);
	if (!buf[*pos]) linerd=0; else { (*pos)++; linerd=1; }
	return linerd;
} /* }}} */

/* manage_sock() - proces requests remaining on a socket {{{ */
static void manage_sock( int id ) {
	
	const char *commands[]={
		"Key",
		"Quit",
		"ValidateNick",
		"GetNickList",
		"MyINFO",
		"GetINFO",
		"Kick",
		"MyPass",
		"Search",
		"MultiSearch",
		"To:",
		"Version",
		"ConnectToMe",
		"MultiConnectToMe",
		"RevConnectToMe",
		"UniSearch",
		""
	};
	const char *sep=" |";
	char buf[BUF_SIZE],tmp[513],*cmd,*par;
	struct timeval tv;
	int pos=0,count,n;
	extern lwlh_t h;
	
	if ((count=recv(user[id]->sock,buf,BUF_SIZE,0))<=0) {
		deluser(id,NULL); return; }
	buf[count]=0;
	if (user[id]->state==2) {
		gettimeofday(&tv,NULL); user[id]->ping=tv.tv_sec; }
	while(buf2line(&pos,buf))
	{
		if (*line) {
			printf("[%s] %s\n",*(user[id]->nick)?user[id]->nick:"Unknown",line);
			lwl_write_log (h, LWL_PRI_INFO, "[%s] %s",*(user[id]->nick)?user[id]->nick:"Unknown",line);
			fflush(stdout);
		}
		strcpy(tmp,line);
		if (!(cmd=strtok(tmp,sep))) continue;
		par=strtok(NULL,sep);
		count=0;
		/* Parse commands {{{ */
		if (*cmd=='$')
			while(*commands[count]) {
				if (!strcasecmp(&cmd[1],commands[count])) break;
				else count++; }
		else 
			if (*cmd=='<') count=-1;
			else count=-2;
			if (((user[id]->state==0)&&(count!=0))||
					((user[id]->state==1)&&(count!=2))||
					((user[id]->state==2)&&(count==2))) { deluser(id,NULL); return; }
			switch(count) {
				/* $Msg {{{ */
				case -1: sprintf(tmp,"<%s>",user[id]->nick);
					 if (!strcasecmp(cmd,tmp)) {
						 if(conf.allow_chat==1)
							 send_mcast(line);
						 else {
							 lwl_write_log (h, LWL_PRI_DEBUG, "Chat is not allowed");
						 }
						 return; }
					 else {
						 puts("Msg: Fake nick not allowed.");
						 lwl_write_log (h, LWL_PRI_INFO, "MyINFO: Fake nick not allowed, %s", user[id]->nick);
					 }
					 continue; /* }}} */
				/* $Key {{{ */
				case 0: if (!validkey(id,par)) return;
						if (user[id]->state==0) user[id]->state=1;
					continue; /* }}} */
				/* $Quit {{{ */
				case 1: if (!par) continue;
						if (strcasecmp(par,user[id]->nick)) {
							puts("Quit: Fake nick not allowed."); 
							lwl_write_log (h, LWL_PRI_INFO, "MyINFO: Fake nick not allowed, %s", user[id]->nick);
							continue; 
						}
					deluser(id,NULL);
					return; /* }}} */
				/* $ValidateNick {{{ */
				case 2: if (!validnick(id,par)) return;
						user[id]->state=2;
					sendf_mcast("$Hello %s",user[id]->nick);
					privmsg(NULL,user[id],"Welcome to DConnect Deamon for Linux");
					privmsg(NULL,user[id],conf.motd);
					continue; /* }}} */
				/* $GetNickList {{{ */
				case 3: cmd=(char *)malloc(21*NUSERS+12);
					if (!cmd) {
						puts("GetNickList: Memory allocation error."); 
						lwl_write_log (h, LWL_PRI_ERR, "GetNickList: Memory allocation error");
						continue;
					}
					strcpy(cmd,"$NickList ");
					for(n=0;n<NUSERS;n++)
						if (user[n]->state==2) {
							strcat(cmd,user[n]->nick);
							strcat(cmd,"$$");
						}
					send_to(user[id],cmd);
					free(cmd);
					continue; /* }}} */
				/* $MyINFO {{{ */
				case 4: if (fill_info(user[id],line)) {
						if (user[id]->share<(conf.minshare*1024*1024)) {
							sprintf(tmp,"You must share at least %LuMB on this hub.",conf.minshare);
							deluser(id,tmp);
						}
						else send_mcast(line);
					}
					continue; /* }}} */
				/* $GetINFO {{{ */
				case 5: if (!par) continue;
						if ((n=nick2id(par))<0)	{
							puts("GetINFO: No such user.");
							lwl_write_log (h, LWL_PRI_INFO, "GetINFO: No such user");
							continue;
						}
					sendf_to(user[id],"$MyINFO $ALL %s %s$ $%s%c$%s$%Lu$",user[n]->nick,user[n]->desc,user[n]->ctype,user[n]->flag,user[n]->email,user[n]->share);
					continue; /* }}} */
				/* $Kick {{{ */
				case 6:
					lwl_write_log (h, LWL_PRI_INFO, "Kick: Not supported yet...[FIXME]");
					privmsg(NULL,user[id],"Kick is not supported yet...");
					continue; /* }}} */
				/* $MyPass {{{ */
				case 7:
					lwl_write_log (h, LWL_PRI_INFO, "MyPass: Not supported yet...[FIXME]");
					privmsg(NULL,user[id],"Password is not supported yet...");
					continue; /* }}} */
				/* $Search {{{ */
				case 8: if (!par) continue;
						strtok(par,":");
					if (!strcmp(user[id]->ip,par)) send_mcast(line);
					else {
						puts("Search: Incorrect IP.");
						lwl_write_log (h, LWL_PRI_INFO, "Search: Incorrect IP");
					}
					continue; /* }}} */
				/* $MultiSearch {{{ */
				case 9:
					lwl_write_log (h, LWL_PRI_INFO, "MultiSearch: Not supported yet...[FIXME]");
					continue; /* }}} */
				/* $To: {{{ */
				case 10: if (!par) continue;
						 if ((n=nick2id(par))<0) {
							 puts("To: No such user.");
							 lwl_write_log (h, LWL_PRI_INFO, "To: No such user");
							 continue;
						 }
					 if (!(par=strtok(NULL,sep))) continue;
					 if (strcasecmp(par,"From:")) continue;
					 if (!(par=strtok(NULL,sep))) continue;
					 if (strcasecmp(user[id]->nick,par)) {
						 puts("From: Fake nick not allowed.");
						 lwl_write_log (h, LWL_PRI_INFO, "From: Fake nick not allowed");
						 continue;
					 }
					 if(conf.allow_chat==1)
						 send_to(user[n],line);
					 else {
						 privmsg(NULL,user[id],"Chat is not allowed");
						 lwl_write_log (h, LWL_PRI_DEBUG, "Chat is not allowed");
						 lwl_write_log (h, LWL_PRI_DEBUG, line);
					 }
					 continue; /* }}} */
				/* $Version {{{ */
				case 11: if (!par) continue;
						 strcpy(user[id]->ver,par);
					 continue; /* }}} */
				/* $ConnectToMe {{{ */
				case 12: if (!par) continue;
						 if ((n=nick2id(par))<0) {
							 puts("ConnectToMe: No such user.");
							 lwl_write_log (h, LWL_PRI_INFO, "ConnectToMe: No such user");
							 continue;
						 }
					 if (!(par=strtok(NULL,":"))) continue;
					 if (strcmp(user[id]->ip,par)) {
						 puts("ConnectToMe: Incorrect IP.");
						 lwl_write_log (h, LWL_PRI_INFO, "ConnectToMe: Incorrect IP");
						 continue;
					 }
					 send_to(user[n],line);
					 continue; /* }}} */
				/* $MultiConnectToMe (?) {{{ */
				case 13: if (!par) continue;
						 if ((n=nick2id(par))<0) {
							 puts("MultiConnectToMe: No such user.");
							 lwl_write_log (h, LWL_PRI_INFO, "MultiConnectToMe: No such user");
							 continue;
						 }
					 if (!(par=strtok(NULL,":"))) continue;
					 if (strcmp(user[id]->ip,par)) {
						 puts("MultiConnectToMe: Incorrect IP.");
						 lwl_write_log (h, LWL_PRI_INFO, "MultiConnectToMe: Incorrect IP");
						 continue;
					 }
					 send_to(user[n],line);
					 continue; /* }}} */
				/* $RevConnectToMe {{{ */
				case 14:
					 lwl_write_log (h, LWL_PRI_INFO, "RevConnectToMe: Not supported yet...[FIXME]");
					 privmsg(NULL,user[id],"Passive mode not supported yet. Please, turn this option off.");
					 continue; /* }}} */
				/* $UniSearch {{{ */
				case 15:
					 lwl_write_log (h, LWL_PRI_INFO, "UniSearch (dctc extension): Not supported yet...[FIXME]");
					 privmsg(NULL,user[id],".");
					 continue; /* }}} */
				default: printf("Unknown command \"%s\" - ignored.\n",cmd);
					 lwl_write_log (h, LWL_PRI_INFO, "Unknown command \"%s\" - ignored",cmd);
			}
			/* }}} */
	}
} /* }}} */

/* listen_thread() - listen for new connections {{{ */
void * listen_thread( void * args ) 
{
	int new_sock,remote_size;
	struct sockaddr_in remote;
	char *ip;
	
	setuid(conf.uid_num);
	setgid(conf.gid_num);
	while(1)
	{
		remote_size=sizeof(struct sockaddr_in);
		if ( (new_sock = accept( listen_sock,(struct sockaddr *)&remote,&remote_size))<0 )
		{
			if (errno!=EINTR) {
				lwl_write_log (h, LWL_PRI_CRIT, "accept error: %s", strerror(errno));
				finish(0);
			}
			else 
				continue;
		}
		printf("Connection from %s:%d\n",ip=inet_ntoa(remote.sin_addr),ntohs(remote.sin_port));
		lwl_write_log (h, LWL_PRI_INFO, "Connection from %s:%d",ip=inet_ntoa(remote.sin_addr),ntohs(remote.sin_port));
		adduser(&new_sock,ip);
		close(new_sock);
	}
	pthread_exit(0);
} /* }}} */

/* init_var() - install the signal handler and initialize variables {{{ */
static void init_var( char *argv0 ) {
	signal(SIGPIPE,finish);
	signal(SIGHUP,finish);
	signal(SIGINT,finish);
	signal(SIGTERM,finish);
	
	FD_ZERO(&sockfdset);
	NUSERS=0;
	bzero(user,MAXUSERS*sizeof(struct userrec *));
	bzero(&conf,sizeof(struct config));

	/* Location of config file */
	free(conf.file);
	conf.file=(char *)malloc(strlen(CONFIGDIR)+strlen(CONFIG_FILE)+1);
	sprintf(conf.file, "%s/%s", CONFIGDIR, CONFIG_FILE);
	
	/* Location of log file */
	free(conf.log);
	conf.log=(char *)malloc(strlen(LOG_DIR)+strlen(DCD_LOG_FILE)+1);
	sprintf(conf.log, "%s/%s", LOG_DIR, DCD_LOG_FILE);
	
	/* set up default values	*/
	conf.listen_port=DEFAULT_PORT;
	conf.daemon=DAEMON;

	/* set default to daemon user/group */
	conf.uid_num=2;
	conf.gid_num=2;
	conf.hubname=(char *)malloc(strlen(HUBNAME)+1);
	strcpy(conf.hubname,HUBNAME);
	conf.motd=(char *)malloc(strlen(MOTD)+1);
	strcpy(conf.motd,MOTD);
	conf.userlimit=USERLIMIT;
	conf.allow_broken_key=ALLOW_BROKEN_KEY;
	conf.allow_chat=ALLOW_CHAT;
	conf.ping_timeout=PING_TIMEOUT;
	conf.register_timeout=REGISTER_TIMEOUT;
	conf.nick_pattern=(char *)malloc(strlen(NICK_PATTERN)+1);
	strcpy(conf.nick_pattern,NICK_PATTERN);
	/* end of default values */
	
	__progname=get_progname(argv0);
	randomize();
} /* }}} */


/* Main program: */
/* main() {{{ */
int main(int argc,char *argv[]) {
	int i,maxfd;
	struct timeval timeout;
	extern lwlh_t h;
	
	fd_set readfdset;
	/* init variables */
	init_var(argv[0]);
	
	/* parse command-line options	*/
	parse_options( &conf, argc, argv );
	
	/* Init log-files for lwl */
	h = lwl_alloc ();
	init_log(&conf,h);
	
	/* read config file */
	read_config(&conf);
	
	maxfd=getdtablesize();
	
	show_config(&conf);
	
	/* logging via syslog */
	openlog ("dcd", LOG_PID | LOG_CONS, LOG_DAEMON);
	syslog(LOG_NOTICE, "Initializing, DConnect Daemon");
	lwl_write_log (h, LWL_PRI_INFO, "Initializing, DConnect Daemon");
	
	/* setup and bind a listening socket */
	if ((listen_sock=socket(AF_INET,SOCK_STREAM,0))==-1) {
		lwl_write_log (h, LWL_PRI_CRIT, "Socket error: %s", strerror(errno));
		finish(0);
	}
	setsockopts(&listen_sock);
	local.sin_family=AF_INET;
	local.sin_port=htons(conf.listen_port);
	local.sin_addr.s_addr=INADDR_ANY;
	bzero(&(local.sin_zero),8);
	if (bind(listen_sock,(struct sockaddr *)&local,sizeof(struct sockaddr))<0) {
		lwl_write_log (h, LWL_PRI_CRIT, "Can't bind to socket: %s", strerror(errno));
		finish(0);
	}
	if (listen(listen_sock,5)<0) {
		lwl_write_log (h, LWL_PRI_CRIT, "Error in listening socket: %s", strerror(errno));
		finish(0);
	}
	
	/* daemonize and set owner to proper user */
	if (conf.daemon)
		if (daemon(0,0)<0)
			lwl_write_log (h, LWL_PRI_CRIT, "Error when starting as daemon: %s", strerror(errno));
	setuid(conf.uid_num);
	setgid(conf.gid_num);
	
	/* create listening thread */
	if (pthread_create( &listen_th, NULL, (void *)listen_thread, NULL)!=0) {
		lwl_write_log (h, LWL_PRI_CRIT, "Error when creating thread: %s", strerror(errno));
		finish(0);
	}
	
	/* main loop - finish only when error or killed with a signal */
	while(1) {
		/* 
		 * we use 1ms timeout because we want select() to proces new users even when
		 * there is no traffic on the sockets
		 */
		
		timeout.tv_sec=0; timeout.tv_usec=1000;
		bcopy(&sockfdset,&readfdset,sizeof(readfdset));
		
		if (select(maxfd,&readfdset,NULL,NULL,&timeout)<0) {
			if (errno!=EINTR) {
				lwl_write_log (h, LWL_PRI_CRIT, "Error during select(): %s", strerror(errno));
				finish(0);
			}
			else 
				continue;
		}
		
		/* this needs to be a reverse loop because of the method used in deluser() */
		for (i=NUSERS-1;i>=0;i--) { 
			if (user[i]) {
				if (FD_ISSET(user[i]->sock,&readfdset))
					manage_sock(i);
			}
			if (user[i]) check_timeout(i);
		}
	}
	
	finish( 0 );
	return 0;
} /* }}} */

/* VIM Settings {{{
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * soft-stop-width: 4
 * c indent on
 * End:
 * vim600: sw=4 ts=4 sts=4 cindent fdm=marker
 * vim<600: sw=4 ts=4
 * }}} */

