static char rcs_id[] =
    "$Id: misc.c,v 1.42 2002/07/31 14:35:14 blues Exp $";

/* Intro {{{
 * ---------------------------------------------------------------- 
 *  DirectConnect HUB for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dc.ds.pg.gda.pl/
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- 
 * }}} */

// include for PCH file
#include "pch.h"

/* ChangeLog  {{{
 * $Log: misc.c,v $
 * Revision 1.42  2002/07/31 14:35:14  blues
 * - one TODO is out - it's possible now to turn off chats
 *
 * Revision 1.41  2002/07/31 12:56:11  blues
 * - basic frame for $UniSearch
 *
 * Revision 1.40  2002/07/30 15:43:32  blues
 * - intro hidden
 *
 * Revision 1.39  2002/07/20 19:13:02  blues
 * - more helper signs for vim
 *
 * Revision 1.38  2002/07/20 16:18:16  blues
 * - things to use with vim's slidding functions
 *
 * Revision 1.37  2002/07/01 22:44:09  blues
 * - first part helper functions for vim - only for testing temporary...
 *
 * Revision 1.36  2002/06/30 09:11:37  blues
 * - change ownership of logfile
 *
 * Revision 1.35  2002/06/30 07:14:01  blues
 * - cosmetics
 *
 * Revision 1.34  2002/06/30 06:44:10  blues
 * - more logging
 *
 * Revision 1.33  2002/06/30 05:53:45  blues
 * - more logging
 *
 * Revision 1.32  2002/06/30 05:00:05  blues
 * - log PID too...
 *
 * Revision 1.31  2002/06/30 04:53:01  blues
 * - new commanline option - alternate log file
 *
 * Revision 1.30  2002/06/30 04:04:08  blues
 * - added MOTD utility
 *
 * Revision 1.29  2002/06/30 02:03:10  blues
 * - even more cleanups
 * - UID and GID are now config options
 * - status expanded
 *
 * Revision 1.28  2002/06/30 01:28:07  blues
 * - more cleanups
 *
 * Revision 1.27  2002/06/30 01:17:59  blues
 * - some cleanups
 *
 * Revision 1.26  2002/06/29 23:50:59  blues
 * - massive attack:
 * - new logging scheme - used Log Writer Library
 * - autoconf stuff adapted partially
 *
 * Revision 1.25  2002/05/31 17:55:29  blues
 * - fixed handling config, reverted my mistakes, fixed initscripts and specs
 *
 * Revision 1.24  2002/05/28 18:40:19  sebo
 * Simple config file parser and minimum share requirements.
 * Please view the changes and test it.
 *
 * Revision 1.23  2002/05/18 20:07:31  ventox
 * - type name 'status_t' changed to '_status_t'
 *
 * Revision 1.22  2002/05/14 09:59:51  sebo
 * - empty users bugfix
 * - registration timeout introduced (default = 30sec.)
 * - a listen() backlog issue corrected
 *
 * Revision 1.21  2002/05/08 11:00:43  sebo
 * Some update
 *
 * Revision 1.20  2002/05/07 08:42:27  sebo
 * Problem with libwrap hopfuly solved.
 *
 * Revision 1.19  2002/05/06 22:03:56  sebo
 * Ignoring too long lines instead of shutting down hub. Not tested 'cause I'm going to bed ;-)
 *
 * Revision 1.18  2002/04/28 12:36:19  sebo
 * Daemon mode now works (I hope) and is the default. `-d' debug mode introduced.
 *
 * Revision 1.17  2002/04/27 18:21:10  ventox
 * Initial revision
 *
 * }}} */

/* include local header files {{{ */
#include "main.h"
#include "conf.h"
#include "match.h"
 /* }}} */

extern struct userrec *user[];
extern struct config conf;
extern int NUSERS;
extern struct request_info req;
extern char *__progname;

static char * g_module_name;

/* some helper functions {{{ */
/* _to_lower() {{{ */
char * _to_lower( char * _s ) {
	char * _t = _s;
	ASSERT( _t );
	
	while ( *_t != '0' )
		*(_t++) = tolower( *_t );
	
	return _s;
} /* }}} */

/* _module__finalize() - module {{{ */  
_status_t _module__finalize( void ) {
	if ( g_module_name != NULL )
		free( g_module_name );
	
	return OK;
} /* }}} */

/* _module__initialize() {{{ */
_status_t _module__initialize( char ** argv ) {
	/* module name & location */
	char * _t = strrchr( *argv, _PATH );
	
	if ( _t != NULL ) 
		_t++; 
	else 
		_t = *argv;
	
	g_module_name = (char *)malloc( strlen( _t ) * sizeof( char ) );    
	
	ASSERT( g_module_name );    
	
	_to_lower( strcpy( g_module_name, _t ) );
	
	/* options */
	return OK;
} /* }}} */

/* _module__get_name() {{{ */
_vXhz_CONST char * _module__get_name( void ) { 
	return (_vXhz_CONST char *)g_module_name; 
} /* }}} */
/* }}} */
 
/* show_usage - just show a brief usage {{{ */
void show_usage( void ) {
	printf( "\nDConnect Hub.\n" );
	/* not working, so I use __progname for now - rawsock */
	// printf( "Usage:\t%s [options]\n\n", _module__get_name() );
	printf( "Usage:\t%s [options]\n\n", __progname );
	printf( "-h\t\t this help screen\n" );
	printf( "-c config_file\t use alternate config file\n" );
	printf( "-l log_file\t use alternate log file\n" );
	printf( "-d\t\t debug mode\n\n" );
	exit( 0 );
} /* }}} */

/* parse_options() - parse command-line options {{{ */
void parse_options( struct config *conf, int argc, char * argv[] ) {
	int i;
	
	/* seg fault with this (?!) - rawsock */
	//_module__initialize( argv );

	for ( i = 1; i < argc; i++ )
	{
		if ( argv[i][0] != '-' ) 
			show_usage( );
		
		switch(argv[i][1])
		{
			case 'h': show_usage(); 
				  break;
			case 'c': if (argc<i+2) show_usage(); 
					  else i++;
				  if (conf->file) free(conf->file);
				  conf->file=(char *)malloc(strlen(argv[i])+1);
				  strcpy(conf->file,argv[i]);
				  break;
			case 'l': if (argc<i+2) show_usage();
				  else i++;
				  if (conf->log) free(conf->log);
				  conf->log=(char *)malloc(strlen(argv[i])+1);
				  strcpy(conf->log,argv[i]);
				  break;
			case 'd': conf->daemon=0; 
				  break;
			default: printf("Unknown option: `%s'. Try `-h' for help.\n\n",argv[i]);
				 exit(0);
		}
	}
} /* }}} */

/* get_progname() - from openssh {{{ */
char *get_progname(char *argv0) {
#ifdef HAVE___PROGNAME
	extern char *__progname;
	return __progname;
#else
	char *p;
	if (argv0==NULL) return "unknown";
	
	p=strrchr(argv0,'/');
	if (p==NULL) p=argv0; else p++;
	return p;
#endif
} /* }}} */

/* randomize()	- feed a random numbers generator {{{ */
void randomize( void ) {
	unsigned int seed;
	
	FILE * rdev = fopen( "/dev/urandom", "r" );
	if ( rdev != NULL ) {
		seed = fgetc( rdev ); fclose( rdev );
	}
 
	seed += getpid() + time( NULL );
	srand( seed );
} /* }}} */

/* lockgen()	- lock generator: 'salt Pk=privkey' {{{ */
void lockgen(char *lock) {
	int salt_len, pk_len, n;
	
	salt_len = 50 + rand() % 50;
	pk_len = 5;
	
	for(n=0;n<salt_len;n++) lock[n]='%'+rand()%('z'-'%');
	lock[salt_len]=0;
	strcat(lock," Pk=");
	for(n=0;n<pk_len;n++) lock[salt_len+4+n]='%'+rand()%('z'-'%');
	lock[salt_len+4+pk_len]=0;
} /* }}} */

/* validnick() -  check if a given nick is a valid one. If not - deluser. {{{ */
int validnick(int id,char *nick) {
	int n=0;
	char reason[256];
	const char *reserved[]={
		"Admin",
		"Hub",
		"Hub-Security",
		"Vandel\\Debug",
		"Client",
		""
	};
	if (!nick) { deluser(id,NULL); return 0; }
	if (!*nick) { deluser(id,NULL); return 0; }
	if (*(conf.nick_pattern))
		if (!match(conf.nick_pattern,nick))
		{
			sprintf(reason,"Your nick doesn't match the `%s' pattern.",conf.nick_pattern);
			deluser(id,reason);
			return 0;
		}
	while(*reserved[n])
		if (!strcasecmp(nick,reserved[n++]))
		{ 
			deluser(id,"This nick is reserved!");
			return 0; 
		}
	for(n=0;n<strlen(nick);n++)
		if ((nick[n]<33)||(nick[n]>126)||(nick[n]=='$'))
		{ 
			deluser(id,"Your nick is invalid!"); 
			return 0; 
		}
	for(n=0;n<NUSERS;n++)
		if (!strcmp(user[n]->nick,nick))
		{
			deluser(id,"Your nick is already in use!"); 
			return 0;
		}
	strcpy(user[id]->nick,nick);
	return 1;
} /* }}} */

/* validkey() - check for a valid $Key sequence - FIXME {{{ */
int validkey(int id,char *key) {
	if (conf.allow_broken_key) return 1;
	if (!key) { deluser(id,NULL); return 0; }
	/* checking here - FIXME */
	return 1;
} /* }}} */

/* fill_info() - fill user's record with data received in $MyINFO	 {{{ */
int fill_info(struct userrec *usr,char *info) {
	char *i,*tmp,*bak;
	extern lwlh_t h;
	
	bak=(char *)malloc(strlen(info)+1);
	strcpy(bak,info);
	
	tmp=strchr(bak,' '); 
	if (!tmp) { free(bak); return 0; } tmp++;
	
	i=strchr(tmp,' ');
	if (!i) { free(bak); return 0; } *i=0;
	if (strcasecmp(tmp,"$ALL")) 
	{ 
		puts("MyINFO: Unknown format."); 
		lwl_write_log (h, LWL_PRI_INFO, "MyINFO: Unknown format");
		free(bak); return 0; 
	}
	
	tmp=i+1;
	i=strchr(tmp,' '); 
	if (!i) { free(bak); return 0; } *i=0;
	if (strcasecmp(tmp,usr->nick)) {
		puts("MyINFO: Fake nick not allowed.");
		lwl_write_log (h, LWL_PRI_INFO, "MyINFO: Fake nick not allowed, %s", usr->nick);
		free(bak);
		return 0;
	}
	
	tmp=i+1;
	i=strchr(tmp,'$'); if (!i) { free(bak); return 0; } *i=0;
	if (strlen(tmp)>sizeof(usr->desc)-1) {
		puts("fill_info(): Buffer overflow!");
		lwl_write_log (h, LWL_PRI_ERR, "fill_info(): Buffer overflow!");
		free(bak);
		return 0;
	}
	strcpy(usr->desc,tmp);
	
	tmp=i+1;
	i=strchr(tmp,'$'); if (!i) { free(bak); return 0; }
	
	tmp=i+1;
	i=strchr(tmp,'$'); if (!i) { free(bak); return 0; } *i=0;
	usr->flag=*(i-1); *(i-1)=0;
	if (strlen(tmp)>sizeof(usr->ctype)-1) {
		puts("fill_info(): Buffer overflow!");
		lwl_write_log (h, LWL_PRI_ERR, "fill_info(): Buffer overflow!");
		free(bak);
		return 0;
	}
	strcpy(usr->ctype,tmp);
	
	tmp=i+1;
	i=strchr(tmp,'$'); if (!i) { free(bak); return 0; } *i=0;
	if (strlen(tmp)>sizeof(usr->email)-1) {
		puts("fill_info(): Buffer overflow!");
		lwl_write_log (h, LWL_PRI_ERR, "fill_info(): Buffer overflow!");
		free(bak);
		return 0;
	}
	strcpy(usr->email,tmp);
	
	tmp=i+1;
	i=strchr(tmp,'$'); if (!i) { free(bak); return 0; } *i=0;
	sscanf(tmp,"%Lu",&(usr->share));
	free(bak);
	return 1;
} /* }}} */

/* nick2id() - convert user's nick to table index {{{ */
int nick2id(char *nick) {
	int id;
	for(id=0;id<NUSERS;id++) 
		if (!strcasecmp(user[id]->nick,nick)) return id;
	return -1;
} /* }}} */

/* check_timeout() - check clients' times {{{ */
void check_timeout(int id) {
	struct timeval tv;
	
	gettimeofday(&tv,NULL);
	if (conf.ping_timeout)
		if (tv.tv_sec-user[id]->ping>conf.ping_timeout)
		{ 
			deluser(id,"Ping timeout."); 
			return; 
		}
	if (conf.register_timeout&&(user[id]->state!=2))
		if (tv.tv_sec-user[id]->ping>conf.register_timeout)
		{ 
			deluser(id,"Registration timeout."); 
			return; 
		}
} /* }}} */

/* denied() - check if remote host is not allowed to connect {{{ */
int denied(int *sock) {
	request_init(&req,RQ_DAEMON,__progname,RQ_FILE,*sock,0);
	fromhost(&req);
	if (hosts_access(&req)) return 0;
	return 1;
} /* }}} */

/* banned() - check for banned IPs. This is not implemented yet. {{{
 * Maybe never. Read banned entries from config file */
char banned(char *remote) {
	return 0;
} /* }}} */

/* read_config() - read configuration data from file {{{ */
void read_config(struct config *conf) {
	unsigned short int oldport;
	oldport=conf->listen_port; // backup current listening port
	/* here read config file and fill conf struct */
	parse_config(conf);
	/* end of reading */
	/* we should restart the listening thread after listen_port has changed
	 * - not supported yet */
	//if (oldport!=conf->listen_port) restart_listen_thread();
} /* }}} */

/* init_log - initialize log file {{{ */
char init_log(struct config *conf, lwlh_t handler) {
	char *log_file;
	FILE *log;
	int status;
	
	log_file=conf->log;
	status=chown(log_file,conf->uid_num,conf->gid_num);
	log=fopen(log_file,"a+");
	if (!log) {
		puts("Can't open logfile!!");
		openlog ("dcd", LOG_PID | LOG_CONS, LOG_DAEMON);
		syslog(LOG_WARNING, "Can't open logfile %s: %s", conf->log, strerror(errno));
		return;
	}
	lwl_get_log_file(handler);
	lwl_set_attributes (handler,
			LWL_TAG_PREFIX, "dcd",
			LWL_TAG_OPTIONS, LWL_OPT_DATE | LWL_OPT_PID | LWL_OPT_PREFIX | LWL_OPT_PRIORITY | LWL_OPT_TIME | LWL_OPT_USE_LOCALE,
			LWL_TAG_FILE, log,
			LWL_TAG_LEVEL, LWL_PRI_INFO,
			LWL_TAG_DONE);
	lwl_write_log (handler, LWL_PRI_INFO, "Logfile initialized");
	if ( status == -1 ) {
		puts("Can't change permisions of logfile");
		openlog ("dcd", LOG_PID | LOG_CONS, LOG_DAEMON);
		syslog(LOG_NOTICE, "Can't change permisions of logfile %s to UID=%d/GID=%d : %s", conf->log, conf->uid_num, conf->gid_num, strerror(errno));
		lwl_write_log (handler, LWL_PRI_NOTICE, "Can't change permisions of logfile %s to UID=%d/GID=%d : %s", conf->log, conf->uid_num, conf->gid_num, strerror(errno));
	}

	//finish:
	return 0;
} /* }}} */

/* Show configuration used by daemon {{{ */
void show_config(struct config *conf) {
	extern lwlh_t h;

	lwl_write_log (h, LWL_PRI_INFO, "******** Current Configuration ********");
	lwl_write_log (h, LWL_PRI_INFO, "Config file: %s", conf->file);
	lwl_write_log (h, LWL_PRI_INFO, "Log file: %s", conf->log);
	lwl_write_log (h, LWL_PRI_INFO, "Listening port: %u", conf->listen_port);
	lwl_write_log (h, LWL_PRI_INFO, "User UID: %u", conf->uid_num);
	lwl_write_log (h, LWL_PRI_INFO, "Group GID: %u", conf->gid_num);
	lwl_write_log (h, LWL_PRI_INFO, "Daemon mode: %d", conf->daemon);
	lwl_write_log (h, LWL_PRI_INFO, "Hub Name: %s", conf->hubname);
	lwl_write_log (h, LWL_PRI_INFO, "Message of the day: %s", conf->motd);
	lwl_write_log (h, LWL_PRI_INFO, "User limit: %d", conf->userlimit);
	lwl_write_log (h, LWL_PRI_INFO, "Allow broken keys: %d", conf->allow_broken_key);
	lwl_write_log (h, LWL_PRI_INFO, "Ping timeout: %d", conf->ping_timeout);
	lwl_write_log (h, LWL_PRI_INFO, "Registration timeout: %d", conf->register_timeout);
	lwl_write_log (h, LWL_PRI_INFO, "Allowed nick pattern: %s", conf->nick_pattern);
	lwl_write_log (h, LWL_PRI_INFO, "Minimal shared: %lu", conf->minshare);
	lwl_write_log (h, LWL_PRI_INFO, "Minimal slots: %d", conf->minslots);
	lwl_write_log (h, LWL_PRI_INFO, "Allow chat: %d", conf->allow_chat);
	lwl_write_log (h, LWL_PRI_INFO, "***************************************");
} /* }}} */



/* VIM Settings {{{
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * soft-stop-width: 4
 * c indent on
 * End:
 * vim600: sw=4 ts=4 sts=4 cindent fdm=marker
 * vim<600: sw=4 ts=4
 * }}} */

