// $Id: misc.h,v 1.14 2002/07/30 16:15:10 blues Exp $

/* Intro {{{
 * ---------------------------------------------------------------- 
 *  DirectConnect HUB for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dc.ds.pg.gda.pl/
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- 
 * }}} */

#if !defined( __vXhz__MISC_H__INCLUDED__ )
#define __vXhz__MISC_H__INCLUDED__

/* ChangeLog {{{
 * $Log: misc.h,v $
 * Revision 1.14  2002/07/30 16:15:10  blues
 * - all files have now vim helpers - in *.h files only Intro and ChangeLog
 *   are hidden. In *.c files all functions are hidden.
 * - added "/" at the end of address, fixed missing.
 *
 * Revision 1.13  2002/06/29 23:50:59  blues
 * - massive attack:
 * - new logging scheme - used Log Writer Library
 * - autoconf stuff adapted partially
 *
 * Revision 1.12  2002/06/06 11:03:46  blues
 * - add new line at the end of the file - causes warnings in RH
 *
 * Revision 1.11  2002/05/28 18:40:19  sebo
 * Simple config file parser and minimum share requirements.
 * Please view the changes and test it.
 *
 * Revision 1.10  2002/05/14 09:59:51  sebo
 * - empty users bugfix
 * - registration timeout introduced (default = 30sec.)
 * - a listen() backlog issue corrected
 *
 * Revision 1.9  2002/04/27 18:21:10  ventox
 * Initial revision
 *
 * }}} */

// lock generator: 'salt Pk=privkey'
void lockgen( char * lock );

// feed a random numbers generator
void randomize( void );

// check if a given nick is a valid one
int validnick( int id, char * nick );

// check for a valid $Key sequence
int validkey( int id, char * key );

// fill user's record with data received in $MyINFO
int fill_info( struct userrec * usr, char * info );

// convert user's nick to table index
int nick2id( char * nick );

// check clients' idle time
void check_timeout( int id );

// check if remote host is not allowed to connect
int denied( int *sock );

// check for banned IPs
char banned( char * remote );

// read configuration data from file
void read_config( struct config * );

// parse options
void parse_options( struct config * conf, int argc, char * argv[] );

// from openssh
char *get_progname(char *argv0);

/* initialize log file	*/
char init_log(struct config *conf, lwlh_t handler);

/* show config		*/
void show_config(struct config *conf);

#endif /* __vXhz__MISC_H__INCLUDED__ */




/* VIM Settings {{{
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * soft-stop-width: 4
 * c indent on
 * End:
 * vim600: sw=4 ts=4 sts=4 cindent fdm=marker
 * vim<600: sw=4 ts=4
 * }}} */

