// $Id: mutex.h,v 1.4 2002/07/30 16:15:10 blues Exp $

/* Intro {{{
 * ---------------------------------------------------------------- 
 *  DConnect Daemon for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dc.ds.pg.gda.pl/
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- 
 * }}} */

/* ChangeLog {{{
 * $Log: mutex.h,v $
 * Revision 1.4  2002/07/30 16:15:10  blues
 * - all files have now vim helpers - in *.h files only Intro and ChangeLog
 *   are hidden. In *.c files all functions are hidden.
 * - added "/" at the end of address, fixed missing.
 *
 * Revision 1.3  2002/06/30 07:51:00  blues
 * - switched to our main web page
 *
 * Revision 1.2  2002/05/28 18:40:19  sebo
 * Simple config file parser and minimum share requirements.
 * Please view the changes and test it.
 *
 * Revision 1.1  2002/05/18 20:08:22  ventox
 * - initial revision
 * }}} */

#if !defined( __vXhz__MUTEX_H__INCLUDED__ )
#define __vXhz__MUTEX_H__INCLUDED__

#define WAIT_FOREVER   ((DWORD)-1)

// _vmutex
typedef struct _tagMUTEX 
  {
    pthread_t        _owner;
    _int32b          _busy;
    pthread_mutex_t  _handle;
    pthread_cond_t   _cond;
  } 
  _vmutex, * _vmutex_t;

// function creates a mutex object
//_vXhz_LIB_ENTRY _status_t _vmutex_init( _vmutex_t * _mutex, BOOL owned );

#define _vmutex_INIT( _mutex, _owned ) \
  _vmutex_init( (_vmutex_t *)&(_mutex), (BOOL)(_owned) )

// function destroys the specyfied mutex object
//_vXhz_LIB_ENTRY _status_t _vmutex_destroy( _vmutex_t * _mutex );

#define _vmutex_DESTROY( _mutex ) \
  _vmutex_destroy( (_vmutex_t *)&(_mutex) )

// function obtains access to the owner of the specified mutex object
//_vXhz_LIB_ENTRY _status_t _vmutex_acquire( _vmutex_t * _mutex, _int32b timeout );

#define _vmutex_ACQUIRE( _mutex ) \
  _vmutex_acquire( (_vmutex_t *)&(_mutex), WAIT_FOREVER )

// function releases ownership of the specyfied  mutex object
//_vXhz_LIB_ENTRY _status_t _vmutex_release( _vmutex_t * _mutex );

#define _vmutex_RELEASE( _mutex ) \
  _vmutex_release( (_vmutex_t *)&(_mutex) );
    
#endif /* __vXhz__MUTEX_H__INCLUDED__ */




/* VIM Settings {{{
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * soft-stop-width: 4
 * c indent on
 * End:
 * vim600: sw=4 ts=4 sts=4 cindent fdm=marker
 * vim<600: sw=4 ts=4
 * }}} */

