// $Id: net.h,v 1.5 2002/07/30 16:15:10 blues Exp $

/* Intro {{{
 * ---------------------------------------------------------------- 
 *  DirectConnect HUB for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dc.ds.pg.gda.pl/
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- 
 * }}} */

#if !defined( __vXhz__NET_H__INCLUDED__ )
#define __vXhz__NET_H__INCLUDED__

/* ChangeLog {{{
 * $Log: net.h,v $
 * Revision 1.5  2002/07/30 16:15:10  blues
 * - all files have now vim helpers - in *.h files only Intro and ChangeLog
 *   are hidden. In *.c files all functions are hidden.
 * - added "/" at the end of address, fixed missing.
 *
 * Revision 1.4  2002/06/06 11:03:46  blues
 * - add new line at the end of the file - causes warnings in RH
 *
 * Revision 1.3  2002/05/18 12:42:14  blues
 * - nicer comments
 *
 * Revision 1.2  2002/04/27 18:21:10  ventox
 * Initial revision
 *
 * }}} */

/*
 * send to single user
 */
int send_to(struct userrec *usr,char *str);

/*
 * send multicast
 */
int send_mcast(char *str);

/*
 * something like printf(), but to a socket - one destination
 */
int sendf_to(struct userrec *usr,char *format,...);

/*
 * formated send - multicast
 */
int sendf_mcast(char *format,...);

/*
 * this is required, since after disconnect a socket is switched to a TIME_WAIT
 * state and the listening port remains occupied for several minutes
 */
int setsockopts(int *sock);

/*
 * send message to public chat window
 */
void publicmsg(char *from,struct userrec *to,char *msg);

/*
 * send message to private chat
 */
void privmsg(char *from,struct userrec *to,char *msg);

/*
 * disconnect a user with optional reason message
 */
void disconnect(struct userrec *usr,char *reason);

#endif /* __vXhz__NET_H__INCLUDED__ */




/* VIM Settings {{{
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * soft-stop-width: 4
 * c indent on
 * End:
 * vim600: sw=4 ts=4 sts=4 cindent fdm=marker
 * vim<600: sw=4 ts=4
 * }}} */

