// $Id: pch.h,v 1.10 2002/07/30 16:15:10 blues Exp $

/* Intro {{{
 * ---------------------------------------------------------------- 
 *  DConnect Daemon for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dc.ds.pg.gda.pl/
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- 
 * }}} */

#if !defined( __vXhz__PCH_H__INCLUDED__ )
#define __vXhz__PCH_H__INCLUDED__ 

/* ChangeLog {{{
 * $Log: pch.h,v $
 * Revision 1.10  2002/07/30 16:15:10  blues
 * - all files have now vim helpers - in *.h files only Intro and ChangeLog
 *   are hidden. In *.c files all functions are hidden.
 * - added "/" at the end of address, fixed missing.
 *
 * Revision 1.9  2002/06/30 07:51:00  blues
 * - switched to our main web page
 *
 * Revision 1.8  2002/06/29 23:50:59  blues
 * - massive attack:
 * - new logging scheme - used Log Writer Library
 * - autoconf stuff adapted partially
 *
 * Revision 1.7  2002/06/06 11:03:46  blues
 * - add new line at the end of the file - causes warnings in RH
 *
 * Revision 1.6  2002/05/18 20:10:14  ventox
 * - cosmetics in coments
 *
 * Revision 1.1  2002/04/27 18:21:10  ventox
 * Initial revision
 * }}} */

/* include ANSI C/C++ header files */
#include <assert.h>
#include <string.h>
#include <stdarg.h>

#include <errno.h>
#include <stdio.h>

#include <stdlib.h>

#include <memory.h>
#include <ctype.h>

/* -- system dependencies -- */

#if defined( WIN32 )
/* prevent inclusion of winsock.h */
#define _WINSOCKAPI_ 
#endif /* WIN32 */

/* include POSIX threads header files */
#include <pthread.h>

#if defined( WIN32 )
#define WIN32_LEAN_AND_MEAN

/* include Windows base header files */
#pragma pack( 4 )
#include <process.h>
#include <windows.h>

/* include Windows sockets header files	*/
#include <winsock2.h>

/* include Windows TCP/IP header files	*/
#include <ws2tcpip.h>

#else /* WIN32 */

/* include Unix base header files	*/
#include <sys/ioctl.h>
#include <fcntl.h>

#include <sys/signal.h>
#include <unistd.h>

#include <sys/time.h>

#include <syslog.h>
#include <tcpd.h>

/* include Unix sockets header files	*/
#include <sys/types.h>
#include <sys/socket.h>

#include <netdb.h>
#include <net/if.h>

/* include Unix TCP/IP header files	*/
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <netinet/ip.h>

#endif /* !WIN32 */

/* include Log Writer Library		*/
#include <lwl.h>

/* include local header files		*/

#include "config.h"

/* disgnostic support			*/
#include "debug.h"
#include "error.h"

#endif /* __vXhz__PCH_H__INCLUDED__	*/



/* VIM Settings {{{
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * soft-stop-width: 4
 * c indent on
 * End:
 * vim600: sw=4 ts=4 sts=4 cindent fdm=marker
 * vim<600: sw=4 ts=4
 * }}} */

