// $Id: semaphore.h,v 1.5 2002/07/30 16:15:10 blues Exp $

/* Intro {{{
 * ---------------------------------------------------------------- 
 *  DConnect Daemon for Linux
 * 
 *      #(@) Copyright (c) 2002, DConnect development team
 *      #(@) Homepage: http://www.dc.ds.pg.gda.pl/
 *
 *  This  program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You  should  have  received a copy  of  the GNU General Public
 *  License  along  with  this  program;  if  not,  write  to  the
 *  Free  Software  Foundation,  Inc.,  675  Mass  Ave,  Cambridge,
 *  MA 02139, USA. 
 *
 * ---------------------------------------------------------------- 
 * }}} */

#if !defined( __vXhz__SEMAPHORE_H__INCLUDED__ )
#define __vXhz__SEMAPHORE_H__INCLUDED__

/* ChangeLog {{{
 * $Log: semaphore.h,v $
 * Revision 1.5  2002/07/30 16:15:10  blues
 * - all files have now vim helpers - in *.h files only Intro and ChangeLog
 *   are hidden. In *.c files all functions are hidden.
 * - added "/" at the end of address, fixed missing.
 *
 * Revision 1.4  2002/06/30 07:51:00  blues
 * - switched to our main web page
 *
 * Revision 1.3  2002/06/06 11:03:46  blues
 * - add new line at the end of the file - causes warnings in RH
 *
 * Revision 1.2  2002/05/28 18:40:19  sebo
 * Simple config file parser and minimum share requirements.
 * Please view the changes and test it.
 *
 * Revision 1.1  2002/05/18 20:08:22  ventox
 * - initial revision
 * }}} */

#if defined( WIN32 )

#define _SMPHR_LOCKED     (_int32b)(0)
#define _SMPHR_UNLOCKED   (_int32b)(1)

#else /* WIN32 */

#define _SMPHR_LOCKED     (_int32b)(1)
#define _SMPHR_UNLOCKED   (_int32b)(2)

#endif /* !WIN32 */

// semaphore
typedef struct _tagSMPHR
  {
#if defined( WIN32 )
    HANDLE handle;
#else /* WIN32 */
    pthread_cond_t  _cond;
    pthread_mutex_t _handle;
    _int32b _value;
#endif /* !WIN32 */
  } 
  _vsmphr, * _vsmphr_t;

#if defined( __cplusplus )
extern "C" {
#endif /* __cplusplus */

// function initializes an unnamed semaphore object
//_vXhz_LIB_ENTRY _status_t _vsmphr_init( _vsmphr_t * _smphr, uint32b value );

#define _vsmphr_INIT( _smphr, _value ) \
  _vsmphr_init( (_vsmphr_t *)&(_smphr), (uint32b)(_value) )

// functions destroys a semaphore obejct
//_vXhz_LIB_ENTRY _status_t _vsmphr_destroy( _vsmphr_t * _smphr );

#define _vsmphr_DESTROY( _smphr ) \
  _vsmphr_destroy( (_vsmphr_t *)&(_smphr) )

// function returns when the specyfied object signaled state or 
// timeout interval elapses
//_vXhz_LIB_ENTRY _status_t _vsmphr_wait( _vsmphr_t * _smphr, _int32b timeout );

#define _vsmphr_WAIT( _smphr ) \
  _vsmphr_wait( (_vsmphr_t *)&(_smphr), WAIT_FOREVER )

// function waits until the specyfied period of the time elapses
//_vXhz_LIB_ENTRY _status_t _vsmphr_timed_wait( _vsmphr_t * _smphr, _int32b thetime );

#define _vsmphr_TIMED_WAIT( _smphr, _thetime ) \
  _vsmphr_timed_wait( (_vsmphr_t *)&(_smphr), (_int32b)(_thetime) )

// function changes the state of a semaphore to the signaled state
//_vXhz_LIB_ENTRY _status_t _vsmphr_signal( _vsmphr_t * _smphr );

#define _vsmphr_SIGNAL( _smphr ) \
  _vsmphr_signal( (_vsmphr_t *)&(_smphr) )

#if defined( __cplusplus )
}
#endif /* __cplusplus */

#endif /* __vXhz__SEMAPHORE_H__INCLUDED__ */



/* VIM Settings {{{
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * soft-stop-width: 4
 * c indent on
 * End:
 * vim600: sw=4 ts=4 sts=4 cindent fdm=marker
 * vim<600: sw=4 ts=4
 * }}} */

